--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:08:25 08/04/2019
-- Design Name:   
-- Module Name:   C:/Users/mgabr/Spartan6/SinusCosinusFunction01/SinprojecttestBench.vhd
-- Project Name:  SinusCosinusFunction01
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: SinProject
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY SinprojecttestBench IS
END SinprojecttestBench;
 
ARCHITECTURE behavior OF SinprojecttestBench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
    
    COMPONENT SineFunction is
        Port ( clk : in STD_LOGIC;
               reset : in STD_LOGIC;
               strobe : in STD_LOGIC;
               angle : in STD_LOGIC_VECTOR (9 downto 0);
               SineValue : out STD_LOGIC_VECTOR (31 downto 0); --Sine function value in IEEE-754 Single Precision (Float32)
               Sign : out STD_LOGIC); -- Sign: 0 positive, 1 negative
    END COMPONENT;
 
   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal angle : std_logic_vector(9 downto 0) := (others => '0');
   signal strobe : std_logic := '0';

   --Outputs
   signal SineValOut : STD_LOGIC_VECTOR(31 DOWNTO 0); 
   signal Signout : STD_LOGIC;

   -- Clock period definitions
   constant clk_period : time := 100 ns; --10 Mhz
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: SineFunction PORT MAP (
          clk => clk,
          reset => reset,
          strobe => strobe,
          angle => angle,
          SineValue => SineValOut,
          Sign => Signout
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10; --1us

      -- insert stimulus here 
        reset <= '0';        
		strobe  <= '0';		
		angle <= b"0000000000";
			
		wait for 1 ms;
		reset <= '1'; 
		
		angle <= b"0000000000";
		strobe  <= '1';
		
		wait for 1 ms;
		strobe  <= '0';		
		
		
		wait for 1 ms;
		angle <= b"0000000001";
		strobe  <= '1';
		
		wait for 1 ms;
		strobe  <= '0';		
				
		wait for 1 ms;
		angle <= b"0010000000"; --128
		strobe  <= '1';
		
		wait for 1 ms;
		strobe  <= '0';		
		
		wait for 1 ms;
		angle <= b"0011111111"; --255
		strobe  <= '1';	
				
		wait for 1 ms;
		strobe  <= '0';		
				
		wait for 1 ms;
		angle <= b"0100000000"; --256
		strobe  <= '1';

		wait for 1 ms;
		strobe  <= '0';
		
		wait for 1 ms;
        angle <= b"0101110010"; --370
        strobe  <= '1';
        
        wait for 1 ms;
        strobe  <= '0';

		wait for 1 ms;
		angle <= b"0111111111"; --511
		strobe  <= '1';	
		
		wait for 1 ms;
        strobe  <= '0';  
        
        wait for 1 ms;
        angle <= b"1000000000"; --512
        strobe  <= '1';
        
        wait for 1 ms;
        strobe  <= '0';
        
        wait for 1 ms;
        angle <= b"1011111000"; --760
        strobe  <= '1';
        
        wait for 1 ms;
        strobe  <= '0';
        
        wait for 1 ms;
        angle <= b"1110000100"; --900
        strobe  <= '1';
  	
	    wait for 1 ms;
        strobe  <= '0';  
        
        wait for 1 ms;
        angle <=b"1111111111"; --1023
        strobe  <= '1';

      wait;
   end process;

END;
