----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:15:24 07/27/2019 
-- Design Name: 
-- Module Name:    SinProject - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SinProject is
    Port ( clk : in  STD_LOGIC;
	       reset : in  STD_LOGIC;
	       strobe : in  STD_LOGIC;
           Kat : in  STD_LOGIC_VECTOR (9 downto 0);
           AddressSinus : out  STD_LOGIC_VECTOR(7 DOWNTO 0);
           ZnakSinus : out integer range -1 to 1 
         );
end SinProject;

architecture Behavioral of SinProject is
    
  signal KatUnsigned : unsigned(9 downto 0); -- definicja syg lokalnego
  signal AddressUnBig : unsigned(9 downto 0); -- definicja syg lokalnego	
  signal AddressUnsigned : unsigned(7 downto 0); -- definicja syg lokalnego

begin
  
  SEQ: process (reset, clk, strobe, Kat)
  begin
    if rising_edge(clk) then
       if (reset = '0') then
	     AddressSinus <= b"00000000";	
       elsif (strobe = '1') then   
         KatUnsigned <= unsigned(Kat);
		 if (KatUnsigned < 256) then
		    AddressUnsigned <= KatUnsigned(7 DOWNTO 0);
			AddressSinus <= std_logic_vector(AddressUnsigned);
			ZnakSinus <= 1;
		 elsif ((KatUnsigned >= 256) and (KatUnsigned < 511)) then
		    AddressUnBig <= (254-(KatUnsigned-256));
		    AddressUnsigned <= AddressUnBig(7 DOWNTO 0);
			AddressSinus <= std_logic_vector(AddressUnsigned);
			ZnakSinus <= 1;
		 elsif ((KatUnsigned >= 511) and (KatUnsigned <= 766)) then
		    AddressUnBig <= (KatUnsigned-511);
		    AddressUnsigned <= AddressUnBig(7 DOWNTO 0);
			AddressSinus <= std_logic_vector(AddressUnsigned);
			ZnakSinus <= -1;	
		 elsif ((KatUnsigned >= 767) and (KatUnsigned < 1023)) then
		    AddressUnBig <= (255-(KatUnsigned-767));
		    AddressUnsigned <= AddressUnBig(7 DOWNTO 0);
			AddressSinus <= std_logic_vector(AddressUnsigned);
			ZnakSinus <= -1;		
		else	
			AddressSinus <= b"00000000";
		end if;	 
    end if;
   end if;  -- if rising_edge(clk) then
  end process;
   

-- SEQ1: process (clk, ZnakSinus, WartSinus)
-- begin 
--   if (rising_edge(clk)) then    
--     if (ZnakSinus > 0) then
--       DataOut <= WartSinus;
--     else
--       DataOut <= (b"1" & WartSinus(30 DOWNTO 0));
--     end if; 
--   end if;	  
-- end process;

end Behavioral;

