----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 08/11/2019 12:25:04 PM
-- Design Name: 
-- Module Name: SineFunction - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SineFunction is
    Port ( clk : in STD_LOGIC;
           reset : in STD_LOGIC;
           strobe : in STD_LOGIC;
           angle : in STD_LOGIC_VECTOR (9 downto 0);
           SineValue : out STD_LOGIC_VECTOR (31 downto 0); --Sine function value in IEEE-754 Single Precision (Float32)
           Sign : out STD_LOGIC); -- Sign: 0 positive, 1 negative
end SineFunction;

architecture Behavioral of SineFunction is
   
   component SinProject is
       Port ( clk : in  STD_LOGIC;
              reset : in  STD_LOGIC;
              strobe : in  STD_LOGIC;
              Kat : in  STD_LOGIC_VECTOR (9 downto 0);
              AddressSinus : out  STD_LOGIC_VECTOR(7 DOWNTO 0);
              ZnakSinus : out integer range -1 to 1 
            );
   end component;
   
   component SineTable_ROM is
     Port ( 
       clka : in STD_LOGIC;
       ena : in STD_LOGIC;
       addra : in STD_LOGIC_VECTOR ( 7 downto 0 );
       douta : out STD_LOGIC_VECTOR ( 31 downto 0 )
     );
   end component;
   
   signal  OutAddressSinus : STD_LOGIC_VECTOR(7 DOWNTO 0);
   signal  OutZnakSinus :  integer range -1 to 1;
   signal  SinOut32Float : STD_LOGIC_VECTOR ( 31 downto 0 );

begin

  C1: SinProject port map (clk, reset, strobe, angle, OutAddressSinus, OutZnakSinus);
  C2: SineTable_ROM port map (clk, strobe, OutAddressSinus, SinOut32Float);
  
  SEQ1: process (clk, OutZnakSinus, SinOut32Float)
   begin 
     if (rising_edge(clk)) then    
       if (OutZnakSinus > 0) then
         SineValue <= SinOut32Float;
         Sign <= '0';
       else
         SineValue <= (b"1" & SinOut32Float(30 DOWNTO 0));
         Sign <= '1';
       end if; 
     end if;      
   end process;


end Behavioral;
